Xalan-Java 2.7.1: Class Function

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xpath.functions
Class Function

    java.lang.Object
      |
      +--org.apache.xpath.Expression
            |
            +--org.apache.xpath.functions.Function

Direct Known Subclasses:
  FuncCurrent, FuncExtFunction, FuncFalse, FuncLast, FuncPosition, FunctionOneArg, FuncTrue

public abstract class Function
extends Expression

This is a superclass of all XPath functions. This allows two ways for the class to be called. One method is that the super class processes the arguments and hands the results to the derived class, the other method is that the derived class may process it's own arguments, which is faster since the arguments don't have to be added to an array, but causes a larger code footprint.

See Also:
  Serialized Form
Usage:
  **For advanced use only**

Constructor Summary
`Function()`

Method Summary
`void` | `callArgVisitors(XPathVisitor visitor)` Call the visitors for the function arguments.
`void` | `callVisitors(ExpressionOwner owner, XPathVisitor visitor)`
`void` | `checkNumberArgs(int argNum)` Check that the number of arguments passed to this function is correct.
`boolean` | `deepEquals(Expression expr)`
`XObject` | `execute(XPathContext xctxt)` Execute an XPath function object.
`void` | `postCompileStep(Compiler compiler)` This function is currently only being used by Position() and Last().
`void` | `setArg(Expression arg, int argNum)` Set an argument expression for a function.

Methods inherited from class org.apache.xpath.Expression
`asIterator, asIteratorRaw, asNode, assertion, bool, canTraverseOutsideSubtree, error, execute, execute, execute, executeCharsToContentHandler, exprAddChild, exprGetChild, exprGetNumChildren, exprGetParent, exprSetParent, fixupVariables, getColumnNumber, getExpressionOwner, getLineNumber, getPublicId, getSystemId, isNodesetExpr, isStableNumber, num, warn, xstr`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Function

    public Function()

Method Detail

### setArg

    public void setArg(Expression arg,
                       int argNum)
                throws WrongNumberArgsException

  Set an argument expression for a function. This method is called by the XPath compiler.
  Parameters:
    `arg` - non-null expression that represents the argument.
    `argNum` - The argument number index.
  Throws:
    WrongNumberArgsException - If the argNum parameter is beyond what is specified for this function.

### checkNumberArgs

    public void checkNumberArgs(int argNum)
                         throws WrongNumberArgsException

  Check that the number of arguments passed to this function is correct. This method is meant to be overloaded by derived classes, to check for the number of arguments for a specific function type. This method is called by the compiler for static number of arguments checking.
  Parameters:
    `argNum` - The number of arguments that is being passed to the function.
  Throws:
    WrongNumberArgsException -

### execute

    public XObject execute(XPathContext xctxt)
                    throws TransformerException

  Execute an XPath function object. The function must return a valid object.
  Parameters:
    `xctxt` - The execution current context.
  Returns:
    A valid XObject.
  Throws:
    TransformerException -
  Overrides:
    execute in class Expression

### callArgVisitors

    public void callArgVisitors(XPathVisitor visitor)

  Call the visitors for the function arguments.

### callVisitors

    public void callVisitors(ExpressionOwner owner,
                             XPathVisitor visitor)

  See Also:
    `XPathVisitable.callVisitors(ExpressionOwner, XPathVisitor)`

### deepEquals

    public boolean deepEquals(Expression expr)

  Overrides:
    deepEquals in class Expression
  See Also:
    `Expression.deepEquals(Expression)`

### postCompileStep

    public void postCompileStep(Compiler compiler)

  This function is currently only being used by Position() and Last(). See respective functions for more detail.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006 Apache XML Project. All Rights Reserved.